/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/

/*
	This is an optimized version of Dojo, built for deployment and not for
	development. To get sources and documentation, please visit:

		http://dojotoolkit.org
*/

if(!dojo._hasResource['epages.cartridges.de_epages.presentation.widget.EditorPlaceholder']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.cartridges.de_epages.presentation.widget.EditorPlaceholder'] = true;
dojo.provide('epages.cartridges.de_epages.presentation.widget.EditorPlaceholder');




dojo.declare(
	"epages.cartridges.de_epages.presentation.widget.EditorPlaceholder",
	[dijit._Widget, dijit._Templated],
	{
		ep_info: '',
		_info: undefined,
		base64: new epages.string.Base64,
		src : epages.vars.StoreRoot + '/BO/icons/general_img_transparentpixel.gif',

		templateString: '<img width="" height="" ep_group="" ep_info="${ep_info}" title="" alt="" style="" class="epItemContent" src="${src}" />',

		decodeInfo: function(string) {
			if(string && string != ''){
				var info = eval("(" + this.base64.decode(string) + ")");
				if (info.formData !== undefined){ 
					info.formData = $H(info.formData);
				}
				return info;
			}
	},

		postMixInProperties:function(){
			this.inherited("postMixInProperties", arguments);
			this._info = this.decodeInfo(this.ep_info);
		},
		postCreate: function(){
			this.inherited("postCreate", arguments);
			if(this._info && this._info != ''){
				if(this._info.width == "100%") {
					this.domNode.setAttribute('width',this.domNode.parentNode.offsetWidth);
				}else {
					this.domNode.setAttribute('width',this._info.width);
				}
				if(this._info.height == "100%") {
					this.domNode.setAttribute('height',this.domNode.parentNode.offsetHeight);
				}else {
					this.domNode.setAttribute('height',this._info.height);
				}
				this.domNode.setAttribute('alt',this._info.title);
				this.domNode.setAttribute('title',this._info.title);
				this.domNode.style.backgroundImage = 'url('+epages.locationWebRoot(this._info.preview)+')';
				this.domNode.setAttribute('ep_group',this._info.group);
				var width = (this._info.width.toString().match(/%/)) ? this._info.width : this._info.width+'px';
				var height = (this._info.height.toString().match(/%/)) ? this._info.height : this._info.height+'px';
				var epStyle="background:url('"+this._info.preview+"'); width:"+width+"; height:"+height+";";
				this.domNode.setAttribute('ep_style',epStyle);
			}
		}
	}
);

}

if(!dojo._hasResource['epages.cartridges.de_epages.presentation.widget.TextInlineEditor']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.cartridges.de_epages.presentation.widget.TextInlineEditor'] = true;
dojo.provide('epages.cartridges.de_epages.presentation.widget.TextInlineEditor');



// inline editor for simple (unformatted) text
dojo.declare(
	"epages.cartridges.de_epages.presentation.widget.TextInlineEditor",
	epages.cartridges.de_epages.presentation.widget.InlineEditor,
	{
		postMixInProperties: function() {
			this.inherited("postMixInProperties", arguments);
			this.valueFormatted = this.value.replace(/\<br\s*\/?\>(?:\r?\n)?/gi, "\n");		// formatting for textarea
		},

		create: function() {
			this.inherited('create', arguments);
		},

		show: function() {
			// simple text input
			if (!this.isInited) {
				this._copyStyle(this.contentNode, this._computedStyle);
				this._resizeToContent();
				this.contentNode.style.display = '';
				this.contentNode.style.overflow = 'hidden';
				if (this.undoObject){
					this.undoObject.registerInput(this.contentNode);
				}
				// connect events
				this.connect(this.contentNode, 'click', '_resizeToContent');
				this.connect(this.contentNode, 'onkeyup', '_resizeToContent');
				this.connect(this.contentNode, 'onpaste', '_resizeToContent');
				this.connect(this.contentNode, 'onkeyup', 'onChangeContentNode');
				this.connect(this.contentNode, 'onpaste', 'onChangeContentNode');
				this.isInited = true;
			} else {
				this.contentNode.style.display = '';
			}
			this._resizeToContent();
			this.displayNode.style.display = 'none';
			this.contentNode.focus();
			this.inherited('show', arguments);
		},

		hide: function(evt) {
			if (!this.isInited){
				return;
			}
			if (this.contentNode.value == '') {
				this.displayNode.innerHTML = this._placeHolderText;
			} else {
				this.displayNode.innerHTML = epages.html.encodeEntity(this.contentNode.value, true);
			}
			this.displayNode.style.display = '';
			this.contentNode.style.display = 'none';
			this.inherited('hide', arguments);
		},

		// gets called, when data is changed (from outside)
		onChangeContentNode: function() {
			if(!this.allowLineBreaks){
				this.contentNode.value = this.contentNode.value.replace(/\n/g, "");
			}
			
			this.displayNode.innerHTML = epages.html.encodeEntity(this.contentNode.value);
			this.inherited("onChangeContentNode", arguments);
		}
	}
);

}

if(!dojo._hasResource['epages.cartridges.de_epages.presentation.widget.HtmlInlineEditor']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.cartridges.de_epages.presentation.widget.HtmlInlineEditor'] = true;
dojo.provide('epages.cartridges.de_epages.presentation.widget.HtmlInlineEditor');





dojo.publish('epages/addGlobalSymbol', ['tinymce', window]);
dojo.publish('epages/addGlobalSymbol', ['tinyMCE', window]);

// inline editor for html (formatted) text, uses TinyMCE Rich-Text-Editor
dojo.declare(
	"epages.cartridges.de_epages.presentation.widget.HtmlInlineEditor",
	epages.cartridges.de_epages.presentation.widget.InlineEditor,
	{
		getAction 	: 'JSONGet',
		showPageBreak: 'false',

		postCreate: function() {
			this.inherited('postCreate', arguments);
			epages.topDojo.subscribe('tinymce_windowmanager_open/changeContent',this,'onTinyMCEChangeContent');
			epages.topDojo.subscribe("uimessage/startBusy",this,"hideOnSave");
		},

		show: function() {
			// needed for rendering of editors
			tinymce.DOM.doc = window.document;

			// TinyMCE WYSIWYG Editor
			if (this.displayNode.innerHTML == this._placeHolderText){
				this.displayNode.innerHTML = '';
			}
			if (this.object == null) {
				var doc = this.domNode.ownerDocument;
				var settings = tinyMCE.settings;

				settings.content_element = this.displayNode;
				this.value = (this.getRemoteValue() || "");
				settings.content_element.innerHTML = this.value;

				this.replaceGadgets(settings.content_element);

				settings.body_class = "ShowVisualAid  Inline ";
				if(this.navbar != ""){
					settings.body_class +="mceShow"+ this.navbar;
				}

				this.object = new tinymce.Editor("InlineEditor_" + this.id, settings);

				this.object.onInit.add(dojo.hitch(this, function() {
					// add undo functionality
					if (this.undoObject) {

						// force refresh of content, to get the effects of tinymce cleanup functions
						var content = this.object.getContent();
						this.object.setContent(content);
						this.contentNode.value = content;

						if (this.undoObject){
							this.undoObject.setDefaultValue(this.contentNode);
						}
						this.object.undoManager = new epages.html.TinymceUndoManagerAdapter(
							this.undoObject,
							this.contentNode,
							dojo.hitch(this, 'onChange')
						);

						this.object.onEvent.add(dojo.hitch(this, function() {
							this.undoObject.checkTyping(Boolean(this.object.undoManager.typing));
						}));
					}

				}));

				this.object.render();

				// add css class to iframe
				var iframe = $('InlineEditor_' + this.id + '_ifr', doc);
				$E(iframe).addClassName('EditorIframe');
				iframe.allowTransparency="true";

				this.isInited = true;
			} else {
				this.object.show();
			}
			this.displayNode.style.display = 'none';

			// enable pagebreak button?
			if(this.showPageBreak == 'true') {
				var div = dojo.query('.MCEElementsBox-InsertPageBreak',top.$('MCEElementsBox'));
				if(div) {
					dojo.removeClass(div[0], 'HideElement');
				}
			}

			this.inherited('show', arguments);
		},

		hide: function(evt) {
			if (!this.isInited){
				return;
			}
			this.object.hide();
			this.contentNode.style.display = 'none';
			this.contentNode.value = this.object.getContent().replace(/\s*\<br\s*\/?\>\s*$/, "");
			this.displayNode.innerHTML = this.contentNode.value;
			this.displayNode.style.display = '';
			if(this.undoObject.isTyping == true){
				this.undoObject.checkTyping(false);
			}

			// disable pagebreak button?
			if(this.showPageBreak == 'true') {
				var div = dojo.query('.MCEElementsBox-InsertPageBreak',top.$('MCEElementsBox'));
				if(div) {
					dojo.addClass(div[0], 'HideElement');
				}
			}

			this.inherited('hide', arguments);
		},

		// gets called, when data is changed (from outside)
		onChangeContentNode: function() {
			var value = this.contentNode.value;

			// put value to DOM, replaceGadgets only work with DOM, not with strings
			var tmp = dojo.query("div[name='temp']")[0]
			if( !tmp ) {
				tmp = dojo.create("div", {"name":"temp"});
			}
			tmp.innerHTML = value;
			this.replaceGadgets(tmp);
			value = tmp.innerHTML;

			// update editor
			if(this.object){
				this.object.setContent(value);
			}
			// update displayed content
			this.displayNode.innerHTML = value;
		},

		onTinyMCEChangeContent: function(editorId){
			if(editorId == this.contentNode.id){
				this.onChange();
			}
		},

		getRemoteValue: function() {
			var json = new epages.io.Json();
			var result = json.loadSync(
				'?ObjectID=' + this.objectId + '&ViewAction=' + this.getAction,
				{
					'Attributes': this.attribute,
					'LanguageID': this.languageId
				}
			);
			return result.data[this.attribute];
		},

		hideOnSave: function(id){
			if(id == 'Undobuttons'){
				this.hide();
			}
		},

		replaceGadgets: function (domNode) {
			var gadgets = epages.html.getElementsByClassName('epItemContent', domNode);
			for( var i=0,l=gadgets.length ; i<l ; i++ ) {
				var g = gadgets[i];
				var epInfo = g.getAttribute('ep_info');
				if(!epInfo){
					var epRegEx = new RegExp ("ep_info:(.*)","mig");
					var regExResult = epRegEx.exec(g.className);
					if(regExResult){
						epInfo = regExResult[1];
					}
				}
				if(epInfo){
					new epages.cartridges.de_epages.presentation.widget.EditorPlaceholder({ep_info: epInfo},g);
				}
			}
		}

	}
);

}

if(!dojo._hasResource['epages.cartridges.de_epages.presentation.widget.Createobjectbutton']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.cartridges.de_epages.presentation.widget.Createobjectbutton'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.presentation.widget.Createobjectlink $Revision: 1.17 $

*/
dojo.provide('epages.cartridges.de_epages.presentation.widget.Createobjectbutton');




dojo.declare(
	"epages.cartridges.de_epages.presentation.widget.Createobjectbutton",
	[epages.widget.LocalizedWidget],
	{
		templateString:     '',
		templateString:"<div class=\"Ghost New\">\n\t<a href=\"javascript: void(0)\" data-ep-preview=\"show\" class=\"Createobjectbutton Container\">\n\t\t<i class=\"icon-plus\"></i>\n\t\t${description}\n\t</a>\n</div>\n",
		translationName: 		dojo.moduleUrl('epages.cartridges.de_epages.presentation.widget', 'templates/translation'),

		className:					'',
		objectId:						'',
		description:				'',
		iconFile:						'',
		url :								'?',
		undoWidget:					'',
		languageId:					undefined,
		formNode:						null,
		dialogTitle:				'',
		focusFirstInput:		false,

		_errorInputs:				null,

		postMixInProperties: function() {
			if(!this.languageId) {
				this.languageId = epages.vars.Locale.languageId;
			}

			if(this.iconFile == ''){
				this.iconFile = epages.themeUrl('/images/ico_s_add.png');
			}

			if (this.description == "") {
				this.description = this.translate('New');
			}

			this.focusFirstInput = Boolean(this.focusFirstInput);
			this.inherited("postMixInProperties", arguments);
		},

		postCreate: function () {
			this.inherited("postCreate", arguments);
			this._errorInputs = [];
			// add events to buttons
			this.connect(this.domNode, "onclick", "createObject");
		},

		createObject: function() {
			var undoWidget = $$(this.undoWidget);
			if(undoWidget && undoWidget.existsChanges()) {
				this._confirmSaveChanges();
				return;
			}
			var _this = this;
			var doCreateObject = dojo.hitch(this, function(params, button) {
				var json = new epages.io.Json();
				if (params == null){
					params = {};
				}
				params = dojo.mixin({
					ChangeAction: 'NewObject',
					ObjectID: 		this.objectId,
					Class: 				this.className,
					ViewAction:   'JSONGet',
					Attributes:   'ObjectID,ClassAlias=Class.Alias,IsVisible,Position,Name=NameOrAlias' //isProduct is not set for Forum/Guestbook...
				}, params);
				if (button) {
					button._modalDialogWidget.hide();
				}
				var data = json.loadAsync(this.url, dojo.hitch(this,function(result){
					if(result.error){
						if (button) {
							button._modalDialogWidget.show();
						}
						for( var i=0,iLength=this._errorInputs.length ; i<iLength ; i++ ) {
							$E(this._errorInputs[i]).removeClassName('DialogError');
						}
						this._errorInputs = [];
						var data = result.error.data;
						for( var i=0,iLength=data.Errors.length ; i<iLength ; i++ ) {
							var error = data.Errors[i];
							// find element for error by name
							var input = parent.dojo.query('*[name=' + error.Parameter + ']', button._modalDialogWidget.domNode);
							if (input.length > 0) {
								input = input[0];
								epages.topDojo.publish("uimessage/show", ["", this.translate(error.Reason), "Bubble", {
									typeClass: "Warning",
									sizeClass: "Small",
									element: input,
									attachNode: input.parentNode,
									baseNode: button._modalDialogWidget.domNode
								}]);
								$E(input).addClassName('DialogError');
								this._errorInputs.push(input);
							}
						}
					}
					else{
						if (button) {
							button._modalDialogWidget.destroyRecursive();
						}
						window.setTimeout(function() {
							parent.dojo.publish('Createobjectbutton/objectCreated', [{ result: result }]);
						}, 100);
					}
				}), params);
			});
			var json = new epages.io.Json();
			json.loadAsync(this.url, function(result) {
				if (result.data.snippet !== null) {
					// display create object form
					epages.topDojo.require('epages.widget.Modaldialog');
					var newDiv = epages.topWindow.document.createElement('div');
					epages.topWindow.document.getElementsByTagName('body')[0].appendChild(newDiv);
					this._createObjectWidget = new epages.topWindow.epages.widget.Modaldialog({
						// we have to focus the input ourselves, so disable default autofocus
						autofocus : !_this.focusFirstInput,
						options:{
							title : _this.dialogTitle,
							content: result.data.snippet
						},
						buttons: [{
							label: _this.translate('Insert'),
							cssClass: "Active",
							onclick: function() {
								// get values from form
								var formNode = this._modalDialogWidget.containerNode.getElementsByTagName('form');
								if(formNode){
									var params = {};
									if (formNode.length > 0) {
										formNode = formNode[0];
										for( var i=0,iLength=formNode.elements.length ; i<iLength ; i++ ) {
											var element = formNode.elements[i];
											if ((element.nodeName.match(/INPUT/i) && element.type.match(/HIDDEN|RADIO|TEXT|CHECKBOX/i)) ||
												element.nodeName.match(/TEXTAREA|SELECT/i)) {
												params[element.name] = element.value;
											}
										}
									}
									doCreateObject(params, this);
								}
							}
						}, {
							label: _this.translate('Cancel'),
							onclick: function() {
								this._modalDialogWidget.destroyRecursive();
								parent.dojo.publish('Createobjectbutton/closed');
							}
						}]
					}, newDiv);
					this._createObjectWidget.show();
				} else {
					// empty snippet - no dialog
					// this happens when no template is defined for this class
					doCreateObject();
				}
			},
			{
				'ViewAction': 'JSONSnippet',
				'TemplateAction': 'CreateObjectSnippet',
				'TemplateLanguageID': this.languageId,
				'ObjectID': this.objectId,
				'Class': this.className,
				'DontFail': '1'
			});
		},

		_confirmSaveChanges: function(){
			var me = this;
			parent.dojo.publish("uimessage/show", [
				this.translation.get("SaveQuestion"),
				this.translation.get("CreateObjectDescription"),
				'Dialog',
				{
					titleBar: this.translation.get("ChangeOnContent"),
					sizeClass:"Large",
					typeClass:"Warning",
					buttons: [{
						label: this.translation.get("Save"),
						cssClass: 'Active',
						onclick: function() {
							this._modalDialogWidget.destroyRecursive();
							//if Save was clicked, undowidget saves changes
							$$(me.undoWidget).sendChanges();
							$$(me.undoWidget).undoObject.clear();
							//perform action
							me.createObject();
						}
					},
					{
						label: this.translation.get("Cancel"),
						onclick: function() {
							this._modalDialogWidget.destroyRecursive();
						}
					}]
				}
			]);
		}

	}
);

}

