/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["epages.widget.FormElement"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.FormElement"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.widget.FormElement $Revision: 1.22 $

*/

dojo.provide("epages.widget.FormElement");
dojo.require("epages.widget.FormElements");

(function(dj){

	epages.changeInputType = function( node, type ){
			var _node = dj.clone(node);
				dj.attr( _node , 'type' , type );
				dj.attr( _node , 'value' , node.value );
				dj.place( _node , node , 'after' );
				_node.parentNode.removeChild(node);
			return _node;
		};

	epages.widget.FormElement = function( options, domNode ){
		this.destroy();

		var nodeName = domNode.nodeName.toLowerCase(),
			nodeType,
			widget;

		if( nodeName == 'select' ){
			widget = new epages.widget.FormSelect(options,domNode);
		}
		else if( nodeName == 'textarea' ){
			widget = new epages.widget.FormText(options,domNode);
		}
		else{
			if( dojo.hasClass( domNode, 'Checkbox' ) ){
				domNode = domNode.type != 'checkbox' ? epages.changeInputType( domNode, 'checkbox' ) : domNode;
				widget = new epages.widget.FormCheck(options,domNode);
			}
			else if( dojo.hasClass( domNode, 'Radio' ) ){
				domNode = domNode.type != 'radio' ? epages.changeInputType( domNode, 'radio' ) : domNode;
				widget = new epages.widget.FormCheck(options,domNode);
			}

			nodeType = domNode.getAttribute('type');

			if( /^(file)$/i.test(nodeType) ){
				widget = new epages.widget.FormFile(options,domNode);
			}
			else if( /^(text|password)$/i.test(nodeType) ){
				widget = new epages.widget.FormText(options,domNode);
			}
		}

		if( widget ){

			widget.elementNode = widget.domNode;
			widget.setValue = function( val ) {
				return this.attr( 'value', val );
			}

			widget.setStartUpValue = function( val ) {
				this.attr( 'startupValue', val );
				this.validate();

				return this;
			}

			widget.getValue = function() {
				return this.attr( 'value' );
			}

			widget.isChecked = function() {
				return this.attr( 'checked' );
			}

			widget.setChecked = function( val ){
				return this.attr( 'checked', val );
			}

			return widget;
		}
	};
	epages.widget.FormElement.prototype = new dijit._Widget();

})(dojo);

}
