/*global define, CKEDITOR, setTimeout*/
/*jslint regexp: true, unparam: true*/
define(['testsuite/qunit', 'jquery', 'ep/ui/editor', '$ready!'], function (QUnit, $) {
    'use strict';

    QUnit.module("ckeditor/plugins/textaligngroup");

    var editor1 = $('#uieditor_ckeditortestinstance_test1');

    function selectElementById(id, editorInstance) {
        editorInstance.getSelection().selectElement(editorInstance.document.getById(id));
        return;
    }

    // Instantiate CKE.
    editor1.uiEditor({
        'name' : 'ckeditortestinstance_test1'
    });

    setTimeout(function () {

        QUnit.asyncTest("basic eplineheight plugin tests", function () {
            var editorId = 'uieditor_ckeditortestinstance_test1',
                editorClass = 'cke_1',
                editorInstance = CKEDITOR.instances[editorId],
                menuEntries;

            // Reset CKE data.
            editorInstance.setData('');
            // Check if eplineheight button exists.
            QUnit.equal($('.' + editorClass + ' .cke_button__eptextaligngroup').length, 1, 'the necessary eptextaligngroup button exists');
            // Open submenu.
            $('.' + editorClass + ' .cke_button__eptextaligngroup').trigger('click');

            setTimeout(function () {

                QUnit.equal($('iframe.cke_panel_frame').length, 1, 'submenu is initialized');
                QUnit.equal($('iframe.cke_panel_frame').is(':visible'), true, 'submenu is open');

                // Get all menu entries.
                menuEntries = $('iframe.cke_panel_frame').contents().find('span.cke_menuitem');
                QUnit.equal(menuEntries.length, 4, 'submenu contains 4 entries');

                // Insert a p-tag foreach menu entry.
                menuEntries.each(function (index) {
                    editorInstance.insertHtml('<p id="id_' + index + '">' + $(this).find('a').text() + '</p><br />');
                });

                setTimeout(function () {
                    // Perform listformattings on p-tags.
                    menuEntries.each(function (index) {
                        selectElementById('id_' + index, editorInstance);
                        menuEntries.eq(index).find('a').trigger('click');
                    });

                    // Close submenu.
                    editorInstance.focus();

                    setTimeout(function () {
                        QUnit.equal($('iframe.cke_panel_frame').is(':visible'), false, 'submenu is closed');

                        setTimeout(function () {
                            var data = editorInstance.getData(),
                                fragment = $("<div />"),
                                pTags = $(fragment).html(data).children('p[id^="id_"]'),
                                textAlign = ['', 'center', 'right', 'justify'];

                            QUnit.ok(pTags.length === 4, 'a p-Tag for each text aling mode exist.');
                            pTags.each(function (index) {
                                QUnit.ok($(this).css('text-align') === textAlign[index], 'p-Tag with text alignment "' + ((textAlign[index] === '') ? 'left' : textAlign[index]) + '" exists.');
                            });

                            QUnit.start();
                        }, 200);
                    }, 200);
                }, 500);

            }, 1000);
        });

    }, 2000);
});